diff --git a/include/gpac/internal/media_dev.h b/include/gpac/internal/media_dev.h
index a5ebc20d9d..2679620cf2 100644
--- a/include/gpac/internal/media_dev.h
+++ b/include/gpac/internal/media_dev.h
@@ -108,6 +108,9 @@ typedef struct
 	u8 video_format;
 	Bool video_full_range_flag;
 
+	Bool chroma_location_info_present_flag;
+	u8 chroma_sample_loc_type_top_field, chroma_sample_loc_type_bottom_field;
+
 	Bool colour_description_present_flag;
 	u8 colour_primaries;
 	u8 transfer_characteristics;
@@ -252,7 +255,7 @@ typedef struct
 
 	Bool is_svc;
 	u8 last_nal_type_parsed;
-	s8 last_ps_idx;
+	s8 last_ps_idx, last_sps_idx;
 } AVCState;
 
 typedef struct
diff --git a/share/doc/man/gpac-filters.1 b/share/doc/man/gpac-filters.1
index 84543331ae..04b29264e4 100644
--- a/share/doc/man/gpac-filters.1
+++ b/share/doc/man/gpac-filters.1
@@ -2371,6 +2371,8 @@ cmaf (enum, default: no):      use CMAF guidelines (turns on mvex, truns_first,
 .br
 pad_sparse (bool, default: true): inject sample with no data (size 0) to keep durations in unknown sparse text and metadata tracks
 .br
+force_dv (bool, default: false): force DV sample entry types even when AVC/HEVC compatibility is signaled
+.br
 
 .br
 .SH rfqcp
@@ -2545,19 +2547,19 @@ dv_mode (enum, default: auto): signaling for DolbyVision
 .br
 * auto: signal DV profile if RPU or EL are found
 .br
-* force: always signal DV profile
-.br
 * clean: do not signal and remove RPU and EL NAL units
 .br
-* single: remove EL NAL units
+* single: signal DV profile if RPU are found and remove EL NAL units
 .br
 
 .br
-dv_profile (uint, default: 5): profile for DolbyVision (currently defined profiles are 4, 5, 7, 8, 9)
+dv_profile (uint, default: 0): profile for DolbyVision (currently defined profiles are 4, 5, 7, 8, 9), 0 for auto-detect
 .br
-dv_compatid (enum, default: none): cross-compatibility ID for DolbyVision
+dv_compatid (enum, default: auto): cross-compatibility ID for DolbyVision
 .br
-* none: do not signal compatibility
+* auto: auto-detect
+.br
+* none: no cross-compatibility
 .br
 * hdr10: CTA HDR10, as specified by EBU TR 03
 .br
@@ -7108,6 +7110,8 @@ fullrange (bool, default: false, updatable): video full range flag
 .br
 novsi (bool, default: false, updatable): remove video_signal_type from VUI in AVC|H264 and HEVC
 .br
+novuitiming (bool, default: false, updatable): remove timing_info from VUI in AVC|H264 and HEVC
+.br
 prof (sint, default: -1, updatable): profile indication for AVC|H264
 .br
 lev (sint, default: -1, updatable): level indication for AVC|H264, level_idc for VVC
@@ -7257,7 +7261,7 @@ Description: TX3G unframer
 .br
 
 .br
-This filter converts a single ISOBMFF TX3G stream to a TTXT, SRT, WebVTT or TTML output file.
+This filter converts a single ISOBMFF TX3G stream to TTXT (xml format) unframed stream.
 .br
 
 .br
@@ -7275,7 +7279,7 @@ Description: TX3G to SRT
 .br
 
 .br
-This filter converts a single ISOBMFF TX3G stream to a TTXT, SRT, WebVTT or TTML output file.
+This filter converts a single ISOBMFF TX3G stream to an SRT unframed stream.
 .br
 
 .br
@@ -7293,7 +7297,7 @@ Description: TX3G to WebVTT
 .br
 
 .br
-This filter converts a single ISOBMFF TX3G stream to a TTXT, SRT, WebVTT or TTML output file.
+This filter converts a single ISOBMFF TX3G stream to a WebVTT unframed stream.
 .br
 
 .br
@@ -7311,7 +7315,7 @@ Description: TX3G to TTML
 .br
 
 .br
-This filter converts ISOBMFF TX3G frames from a single stream to TTML frames.
+This filter converts ISOBMFF TX3G stream to a TTML stream.
 .br
 
 .br
@@ -10725,7 +10729,7 @@ Authors: GPAC developers, see git repo history (-log)
 .br
 For bug reports, feature requests, more information and source code, visit https://github.com/gpac/gpac
 .br
-build: 2.1-DEV-rev336-g621f1cab7-master
+build: 2.1-DEV-rev350-gfaec89573-master
 .br
 Copyright: (c) 2000-2022 Telecom Paris distributed under LGPL v2.1+ - http://gpac.io
 .br
diff --git a/share/doc/man/gpac.1 b/share/doc/man/gpac.1
index 6aacec618d..580ef8e7fd 100644
--- a/share/doc/man/gpac.1
+++ b/share/doc/man/gpac.1
@@ -4714,7 +4714,7 @@ Authors: GPAC developers, see git repo history (-log)
 .br
 For bug reports, feature requests, more information and source code, visit https://github.com/gpac/gpac
 .br
-build: 2.1-DEV-rev336-g621f1cab7-master
+build: 2.1-DEV-rev350-gfaec89573-master
 .br
 Copyright: (c) 2000-2022 Telecom Paris distributed under LGPL v2.1+ - http://gpac.io
 .br
diff --git a/share/doc/man/mp4box.1 b/share/doc/man/mp4box.1
index 25d7c59f6d..5c434b0ac1 100644
--- a/share/doc/man/mp4box.1
+++ b/share/doc/man/mp4box.1
@@ -2870,7 +2870,7 @@ Authors: GPAC developers, see git repo history (-log)
 .br
 For bug reports, feature requests, more information and source code, visit https://github.com/gpac/gpac
 .br
-build: 2.1-DEV-rev336-g621f1cab7-master
+build: 2.1-DEV-rev350-gfaec89573-master
 .br
 Copyright: (c) 2000-2022 Telecom Paris distributed under LGPL v2.1+ - http://gpac.io
 .br
diff --git a/src/filters/inspect.c b/src/filters/inspect.c
index 01207236ac..deb418339c 100644
--- a/src/filters/inspect.c
+++ b/src/filters/inspect.c
@@ -3497,7 +3497,7 @@ static void inspect_dump_pid_as_info(GF_InspectCtx *ctx, FILE *dump, GF_FilterPi
 			if (dovi->rpu_present_flag) inspect_printf(dump, " rpu");
 			if (dovi->bl_present_flag) inspect_printf(dump, " base");
 			if (dovi->el_present_flag) inspect_printf(dump, " el");
-			if (dovi->dv_bl_signal_compatibility_id) inspect_printf(dump, " compat %d", dovi->dv_bl_signal_compatibility_id);
+			if (dovi->dv_bl_signal_compatibility_id) inspect_printf(dump, " compatID %d", dovi->dv_bl_signal_compatibility_id);
 			gf_odf_dovi_cfg_del(dovi);
 		}
 	}
diff --git a/src/filters/isoffin_load.c b/src/filters/isoffin_load.c
index 84948168a5..060eb4e44f 100644
--- a/src/filters/isoffin_load.c
+++ b/src/filters/isoffin_load.c
@@ -509,34 +509,24 @@ static void isor_declare_track(ISOMReader *read, ISOMChannel *ch, u32 track, u32
 		if (!gf_sys_is_test_mode())
 			gf_filter_pid_set_property(pid, GF_PROP_PID_TRACK_NUM, &PROP_UINT(track) );
 
-		//Dolby Vision
-		switch (m_subtype) {
-		case GF_ISOM_SUBTYPE_DVHE:
-		case GF_ISOM_SUBTYPE_DVH1:
-		case GF_ISOM_SUBTYPE_DVA1:
-		case GF_ISOM_SUBTYPE_DVAV:
-		case GF_ISOM_SUBTYPE_DAV1:
-		{
-			GF_DOVIDecoderConfigurationRecord *dovi = gf_isom_dovi_config_get(read->mov, track, stsd_idx);
-			if (dovi) {
-				u8 *data = NULL;
-				u32 size = 0;
-				GF_BitStream *bs = gf_bs_new(NULL, 0, GF_BITSTREAM_WRITE);
-				gf_odf_dovi_cfg_write_bs(dovi, bs);
-				gf_bs_get_content(bs, &data, &size);
-				gf_filter_pid_set_property(pid, GF_PROP_PID_DOLBY_VISION, &PROP_DATA_NO_COPY(data, size));
-				gf_bs_del(bs);
-				gf_odf_dovi_cfg_del(dovi);
+		//Dolby Vision - check for any video type
+		GF_DOVIDecoderConfigurationRecord *dovi = gf_isom_dovi_config_get(read->mov, track, stsd_idx);
+		if (dovi) {
+			u8 *data = NULL;
+			u32 size = 0;
+			GF_BitStream *bs = gf_bs_new(NULL, 0, GF_BITSTREAM_WRITE);
+			gf_odf_dovi_cfg_write_bs(dovi, bs);
+			gf_bs_get_content(bs, &data, &size);
+			gf_filter_pid_set_property(pid, GF_PROP_PID_DOLBY_VISION, &PROP_DATA_NO_COPY(data, size));
+			gf_bs_del(bs);
+			gf_odf_dovi_cfg_del(dovi);
 
-				if (gf_isom_get_reference_count(read->mov, track, GF_4CC('v','d','e','p'))) {
-					GF_ISOTrackID ref_id=0;
-					gf_isom_get_reference_ID(read->mov, track, GF_4CC('v','d','e','p'), 1, &ref_id);
-					if (ref_id) gf_filter_pid_set_property(pid, GF_PROP_PID_DEPENDENCY_ID, &PROP_UINT(ref_id));
-				}
+			if (gf_isom_get_reference_count(read->mov, track, GF_4CC('v','d','e','p'))) {
+				GF_ISOTrackID ref_id=0;
+				gf_isom_get_reference_ID(read->mov, track, GF_4CC('v','d','e','p'), 1, &ref_id);
+				if (ref_id) gf_filter_pid_set_property(pid, GF_PROP_PID_DEPENDENCY_ID, &PROP_UINT(ref_id));
 			}
 		}
-			break;
-		}
 
 		//create our channel
 		ch = isor_create_channel(read, pid, track, 0, (codec_id==GF_CODECID_LHVC) ? GF_TRUE : GF_FALSE);
diff --git a/src/filters/mux_isom.c b/src/filters/mux_isom.c
index 609bc5a92f..7a33ff3e49 100644
--- a/src/filters/mux_isom.c
+++ b/src/filters/mux_isom.c
@@ -286,6 +286,7 @@ typedef struct
 #endif
 	Bool mfra;
 	Bool forcesync, refrag, pad_sparse;
+	Bool force_dv;
 	u32 itags;
 	Double start;
 
@@ -3192,6 +3193,8 @@ static GF_Err mp4_mux_setup_pid(GF_Filter *filter, GF_FilterPid *pid, Bool is_tr
 				GF_DOVIDecoderConfigurationRecord *dvcc = gf_odf_dovi_cfg_read_bs(bs);
 				gf_bs_del(bs);
 				if (dvcc) {
+					if (ctx->force_dv)
+						dvcc->force_dv = 1;
 					gf_isom_set_dolby_vision_profile(ctx->file, tkw->track_num, tkw->stsd_idx, dvcc);
 
 					if (!dvcc->bl_present_flag) {
@@ -7289,6 +7292,8 @@ static const GF_FilterArgs MP4MuxArgs[] =
 		, GF_PROP_UINT, "no", "no|cmfc|cmf2", GF_FS_ARG_HINT_EXPERT},
 	{ OFFS(start), "set playback start offset for MP4Box import only. A negative value means percent of media duration with -1 equal to duration", GF_PROP_DOUBLE, "0.0", NULL, GF_FS_ARG_HINT_HIDE},
 	{ OFFS(pad_sparse), "inject sample with no data (size 0) to keep durations in unknown sparse text and metadata tracks", GF_PROP_BOOL, "true", NULL, GF_FS_ARG_HINT_EXPERT},
+	{ OFFS(force_dv), "force DV sample entry types even when AVC/HEVC compatibility is signaled", GF_PROP_BOOL, "false", NULL, GF_FS_ARG_HINT_ADVANCED},
+
 	{0}
 };
 
diff --git a/src/filters/reframe_nalu.c b/src/filters/reframe_nalu.c
index 5d1a974c91..a45c6a2d4d 100644
--- a/src/filters/reframe_nalu.c
+++ b/src/filters/reframe_nalu.c
@@ -1615,22 +1615,118 @@ static void naludmx_set_dolby_vision(GF_NALUDmxCtx *ctx)
 	u32 dv_level = gf_dolby_vision_level(ctx->width, ctx->height, ctx->cur_fps.num, ctx->cur_fps.den, ctx->codecid);
 
 	if (ctx->dv_profile==8) {
-		if (!ctx->dv_compatid) {
+		if (ctx->dv_compatid<2) {
 			GF_LOG(GF_LOG_WARNING, GF_LOG_MEDIA, ("[%s] DV profile 8 used but dv_compatid not set, defaulting to bt709 (=2)\n", ctx->log_name));
-			ctx->dv_compatid = 2;
+			ctx->dv_compatid = 3;
 		}
 	}
+	u32 dv_ccid = ctx->dv_compatid ? (ctx->dv_compatid-1) : 0;
+	u32 dv_profile_id = ctx->dv_profile;
+
+
+	//auto-detect DV profile, check  range, color primaries, EOTF, matrix, and chroma sample location type
+	if (!ctx->dv_profile) {
+		Bool vui_present = GF_FALSE;
+		Bool has_non_def = GF_FALSE;
+		u32 luma_bit_depth=8;
+		u32 fr = 0;
+		u32 cp = 2;
+		u32 tc = 2;
+		u32 mx = 2;
+		u32 cl = 0;
+		if (ctx->avc_state && (ctx->avc_state->last_sps_idx>=0)) {
+			AVC_SPS *sps = &ctx->avc_state->sps[ctx->avc_state->last_sps_idx];
+			luma_bit_depth = sps->luma_bit_depth_m8+8;
+			if (sps->vui_parameters_present_flag) {
+				vui_present = GF_TRUE;
+				if (sps->vui.video_signal_type_present_flag) {
+					fr = sps->vui.video_full_range_flag;
+					has_non_def = GF_TRUE;
+				}
+				if (sps->vui.chroma_location_info_present_flag) {
+					cl = (sps->chroma_format==1) ?  sps->vui.chroma_sample_loc_type_top_field : 2;
+					has_non_def = GF_TRUE;
+				}
+				if (sps->vui.colour_description_present_flag) {
+					cp = sps->vui.colour_primaries;
+					tc = sps->vui.transfer_characteristics;
+					mx = sps->vui.matrix_coefficients;
+					has_non_def = GF_TRUE;
+				}
+			}
+		}
+		else if (ctx->hevc_state && (ctx->hevc_state->last_parsed_sps_id>=0)) {
+			HEVC_SPS *sps = &ctx->hevc_state->sps[ctx->hevc_state->last_parsed_sps_id];
+			luma_bit_depth = sps->bit_depth_luma;
+			if (sps->vui_parameters_present_flag) {
+				vui_present = GF_TRUE;
+				if (sps->chroma_loc_info_present_flag)
+					cl = (sps->chroma_format_idc==1) ?  sps->chroma_sample_loc_type_top_field : 2;
+
+				//check profile compat:  range, color primaries, EOTF, matrix, and chroma sample location type
+				if (sps->video_signal_type_present_flag) {
+					fr = sps->video_full_range_flag;
+					has_non_def = GF_TRUE;
+				}
+				if (sps->colour_description_present_flag) {
+					cp = sps->colour_primaries;
+					tc = sps->transfer_characteristic;
+					mx = sps->matrix_coeffs;
+					has_non_def = GF_TRUE;
+				}
+			}
+		}
+
+		if ((fr==1) && (cp==2) && (tc==2) && (mx==2) && (cl==0)) dv_ccid=0;
+		else if ((fr==0) && (cp==9) && (tc==16) && (mx==9) && (cl==0)) dv_ccid=1;
+		else if ((fr==0) && (cp==1) && (tc==1) && (mx==1) && (cl==0)) dv_ccid=2;
+		else if ((fr==0) && (cp==9) && (tc==18) && (mx==9) && (cl==2)) dv_ccid=4;
+		else if ((fr==0) && (cp==9) && (tc==14) && (mx==9) && (cl==0)) dv_ccid=4;
+		else if ((fr==0) && (cp==9) && (tc==16) && (mx==9) && (cl==2)) dv_ccid=6;
+
+		//we consider that if no VUI but an EL is present, this will be profile 4 compat SRD
+		if (!vui_present && ctx->nb_dv_el)
+			dv_ccid = 2;
+
+
+		if (dv_ccid==2) {
+			if (ctx->nb_dv_el) dv_profile_id = 4;
+			else if (luma_bit_depth==8) dv_profile_id = 9;
+			else dv_profile_id = 8; //or 4
+		}
+		//DV spec: "Note: H.265 (2018-02) requires top-left chroma siting (VUI = 2), if the decoded video is intended for interpretation
+		// according to ITU-R BT.2020-2 or ITU-R BT.2100-1. Previously, H.265 (2016-12) described the default chroma siting as center left (VUI = 0)."
+		//we consider that dv_ccid=6 is allowed for profile 8 ( DV without EL) - this is not clearly written in the spec but matches deployed bitstreams
+		else if (dv_ccid==6) {
+			dv_profile_id = ctx->nb_dv_el ? 7 : 8;
+		}
+		else if ((dv_ccid==1) || (dv_ccid==4)) dv_profile_id = 8;
+		//default to 5 if no EL, 4 if EL
+		else dv_profile_id = ctx->nb_dv_el ? 4 : 5;
+
+		//DV spec: "Note: As of the effective date of this specification, all commercially produced profile 4 and profile 5 Dolby Vision bitstreams
+		// have used center-left siting during chroma downsampling, and are distributed without the VUI value for chroma sample location type.
+		// Those bitstreams are compliant with this specification."
+		//we treat bitstreams not explicitly signaling vui info as valid and assign the CCID according to DV spec
+		if (!has_non_def) {
+			if (dv_profile_id == 4) dv_ccid = 2;
+			else if (dv_profile_id == 5) dv_ccid = 0;
+		}
+	}
+	//not in auto mode, restore value
+	if (ctx->dv_compatid)
+		dv_ccid = ctx->dv_compatid-1;
 
 	memset(dv_cfg, 0, sizeof(u8)*24);
 	GF_BitStream *bs = gf_bs_new(dv_cfg, 24, GF_BITSTREAM_WRITE);
 	gf_bs_write_u8(bs, 1); //version major
 	gf_bs_write_u8(bs, 0); //version minor
-	gf_bs_write_int(bs, ctx->dv_profile, 7);
+	gf_bs_write_int(bs, dv_profile_id, 7);
 	gf_bs_write_int(bs, dv_level, 6);
 	gf_bs_write_int(bs, ctx->nb_dv_rpu ? 1 : 0, 1); //rpu present
 	gf_bs_write_int(bs, ctx->nb_dv_el ? 1 : 0, 1); //el present
 	gf_bs_write_int(bs, 1, 1); //bl_present_flag always true, we don't split streams
-	gf_bs_write_int(bs, ctx->dv_compatid, 4);
+	gf_bs_write_int(bs, dv_ccid, 4);
 	//the rest is zero-reserved
 	gf_bs_write_int(bs, 0, 28);
 	gf_bs_write_u32(bs, 0);
@@ -3701,6 +3797,14 @@ static GF_Err naludmx_initialize(GF_Filter *filter)
 		ctx->nal_length = 4;
 		break;
 	}
+
+	//if profile is forced and comapt_id is in auto mode, fail
+	if (!ctx->dv_compatid) {
+		if (ctx->dv_profile) {
+			ctx->dv_compatid=1;
+			GF_LOG(GF_LOG_WARNING, GF_LOG_MEDIA, ("[%s] DV profile forced but compatID in auto mode, using no compatibility\n", ctx->log_name));
+		}
+	}
 	return GF_OK;
 }
 
@@ -4007,19 +4111,19 @@ static const GF_FilterArgs NALUDmxArgs[] =
 	{ OFFS(dv_mode), "signaling for DolbyVision\n"
 	"- none: never signal DV profile\n"
 	"- auto: signal DV profile if RPU or EL are found\n"
-	"- force: always signal DV profile\n"
 	"- clean: do not signal and remove RPU and EL NAL units\n"
-	"- single: remove EL NAL units"
-	, GF_PROP_UINT, "auto", "none|auto|force|clean|single", GF_FS_ARG_HINT_ADVANCED},
-	{ OFFS(dv_profile), "profile for DolbyVision (currently defined profiles are 4, 5, 7, 8, 9)", GF_PROP_UINT, "5", NULL, GF_FS_ARG_HINT_ADVANCED},
+	"- single: signal DV profile if RPU are found and remove EL NAL units"
+	, GF_PROP_UINT, "auto", "none|auto|clean|single", GF_FS_ARG_HINT_ADVANCED},
+	{ OFFS(dv_profile), "profile for DolbyVision (currently defined profiles are 4, 5, 7, 8, 9), 0 for auto-detect", GF_PROP_UINT, "0", NULL, GF_FS_ARG_HINT_ADVANCED},
 	{ OFFS(dv_compatid), "cross-compatibility ID for DolbyVision\n"
-		"- none: do not signal compatibility\n"
+		"- auto: auto-detect\n"
+		"- none: no cross-compatibility\n"
 		"- hdr10: CTA HDR10, as specified by EBU TR 03\n"
 		"- bt709: SDR BT.709\n"
 		"- hlg709: HLG BT.709 gamut in ITU-R BT.2020\n"
 		"- hlg2100: HLG BT.2100 gamut in ITU-R BT.2020\n"
 		"- bt2020: SDR BT.2020\n"
-		"- brd: Ultra HD Blu-ray Disc HDR", GF_PROP_UINT, "none", "none|hdr10|bt709|hlg709|hlg2100|bt2020|brd", GF_FS_ARG_HINT_ADVANCED},
+		"- brd: Ultra HD Blu-ray Disc HDR", GF_PROP_UINT, "auto", "auto|none|hdr10|bt709|hlg709|hlg2100|bt2020|brd", GF_FS_ARG_HINT_ADVANCED},
 	{ OFFS(bsdbg), "debug NAL parsing in `parser@debug` logs\n"
 		"- off: not enabled\n"
 		"- on: enabled\n"
diff --git a/src/isomedia/avc_ext.c b/src/isomedia/avc_ext.c
index f2b38c20bc..5177a775da 100644
--- a/src/isomedia/avc_ext.c
+++ b/src/isomedia/avc_ext.c
@@ -1475,15 +1475,8 @@ static GF_DOVIDecoderConfigurationRecord* DOVI_DuplicateConfig(GF_DOVIDecoderCon
 	GF_DOVIDecoderConfigurationRecord* out = NULL;
 	GF_SAFEALLOC(out, GF_DOVIDecoderConfigurationRecord);
 	if (!out) return NULL;
-
-	out->dv_version_major = cfg->dv_version_major;
-	out->dv_version_minor = cfg->dv_version_minor;
-	out->dv_profile = cfg->dv_profile;
-	out->dv_level = cfg->dv_level;
-	out->rpu_present_flag = cfg->rpu_present_flag;
-	out->el_present_flag = cfg->el_present_flag;
-	out->bl_present_flag = cfg->bl_present_flag;
-
+	memcpy(out, cfg, sizeof(GF_DOVIDecoderConfigurationRecord));
+	out->force_dv=0;
 	return out;
 }
 
diff --git a/src/media_tools/av_parsers.c b/src/media_tools/av_parsers.c
index 0950bce74f..22028715e2 100644
--- a/src/media_tools/av_parsers.c
+++ b/src/media_tools/av_parsers.c
@@ -5281,6 +5281,9 @@ static s32 gf_avc_read_sps_bs_internal(GF_BitStream *bs, AVCState *avc, u32 subs
 		sps->vui.colour_primaries = 2;
 		sps->vui.transfer_characteristics = 2;
 		sps->vui.matrix_coefficients = 2;
+		//When the chroma_sample_loc_type_top_field and chroma_sample_loc_type_bottom_field are not present, the values of chroma_sample_loc_type_top_field and chroma_sample_loc_type_bottom_field shall be inferred to be equal to 0.
+		sps->vui.chroma_sample_loc_type_top_field = sps->vui.chroma_sample_loc_type_bottom_field = 0;
+
 		/* now read values if possible */
 		sps->vui.video_signal_type_present_flag = gf_bs_read_int_log(bs, 1, "video_signal_type_present_flag");
 		if (sps->vui.video_signal_type_present_flag) {
@@ -5294,9 +5297,10 @@ static s32 gf_avc_read_sps_bs_internal(GF_BitStream *bs, AVCState *avc, u32 subs
 			}
 		}
 
-		if (gf_bs_read_int_log(bs, 1, "chroma_location_info_present_flag")) {
-			gf_bs_read_ue_log(bs, "chroma_sample_location_type_top_field");
-			gf_bs_read_ue_log(bs, "chroma_sample_location_type_bottom_field");
+		sps->vui.chroma_location_info_present_flag = gf_bs_read_int_log(bs, 1, "chroma_location_info_present_flag");
+		if (sps->vui.chroma_location_info_present_flag) {
+			sps->vui.chroma_sample_loc_type_top_field = gf_bs_read_ue_log(bs, "chroma_sample_location_type_top_field");
+			sps->vui.chroma_sample_loc_type_bottom_field = gf_bs_read_ue_log(bs, "chroma_sample_location_type_bottom_field");
 		}
 
 		sps->vui.timing_info_present_flag = gf_bs_read_int_log(bs, 1, "timing_info_present_flag");
@@ -6148,6 +6152,7 @@ s32 gf_avc_parse_nalu(GF_BitStream *bs, AVCState *avc)
 		avc->last_ps_idx = gf_avc_read_sps_bs_internal(bs, avc, 0, NULL, nal_hdr);
 		if (gf_bs_is_overflow(bs)) return -1;
 		if (avc->last_ps_idx < 0) return -1;
+		avc->last_sps_idx = avc->last_ps_idx;
 		return 0;
 
 	case GF_AVC_NALU_PIC_PARAM:
